#include <sys/types.h>
#include <sys/socket.h>
#include <sys/fcntl.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <sys/un.h>
#include <unistd.h>
#include <iostream>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <signal.h>
#include <ctype.h>
#include <string>

int client_sockfd;

void iohandler(int dummy)
{
  //  cerr << ".";
  const int BUFLEN = 100;
  
  char ch;
  char buf[BUFLEN];
  if (read(client_sockfd, buf, BUFLEN) == -1) return;
  for (int i = 0; i < BUFLEN; i++) {
    if (buf[i] == '\r') {
      buf[i] = '\n';
      break;
    }
    if (buf[i] == '\n') {
      break;
    }
  }
  if (string(buf).substr(0, 5) == "quit\n") {
    close(client_sockfd);
    exit(0);
  }
  int len = 0;
  for (int i = 0; i < BUFLEN; i++) {
    if (buf[i] == '\n') break;
    len++;
    buf[i] = toupper(buf[i]);
  }
  //  cout << "len = " << len << endl;
  // note) CR+LF?
  write(client_sockfd, buf, len+1);

}

int main(int argc, char** argv)
{
  int port = 8000;
  if (argc >= 2) {
    port = atoi(argv[1]);
  }
  cout << "port = " << port << endl;
  
  int server_sockfd;
  socklen_t server_len, client_len;
  struct sockaddr_in server_address;
  struct sockaddr_in client_address;

  if ((server_sockfd = socket(PF_INET, SOCK_STREAM, 0)) < 0) {
    cerr << "error: socket" << endl;
    exit(1);
  }

  bzero((char *)&server_address, sizeof(server_address));
  server_address.sin_family = AF_INET;
  //  server_address.sin_addr.s_addr = htonl(INADDR_ANY);
  server_address.sin_addr.s_addr = inet_addr("127.0.0.1");
  server_address.sin_port = htons(port);

  server_len = sizeof(server_address);
  if (bind(server_sockfd, (struct sockaddr *)&server_address, server_len) < 0){
    cerr << "error. bind(): " << strerror(errno) << endl;
    exit(1);
  }

  if (listen(server_sockfd, 5) < 0) {
    cerr << "error. listen(): " << strerror(errno) << endl;
    exit(1);
  }

  printf("server waiting\n");

  client_len = sizeof(client_address);
  client_sockfd = accept(server_sockfd, (struct sockaddr *)&client_address,
                         &client_len);
  if (client_sockfd == -1) {
    cerr << "error. accept(): " << strerror(errno) << endl;
    exit(1);
  }
  cerr << "connected." << endl;
  close(server_sockfd);

  struct sigaction act;
  act.sa_handler = iohandler;
  sigemptyset(&act.sa_mask);
  act.sa_flags = 0;
  sigaction(SIGIO, &act, NULL);
    
  if (fcntl(client_sockfd, F_SETOWN, getpid()) == -1) {
    cerr << "error. fcntl(): " << strerror(errno) << endl;
    exit(1);
  }
  if (fcntl(client_sockfd, F_SETFL, O_NONBLOCK|O_ASYNC) == -1) {
    cerr << "error. fcntl(): " << strerror(errno) << endl;
    exit(1);
  }

  while(1) {


  }

  close(client_sockfd);
  exit(0);

}
